using System;
using Games.DiceLib;
using System.Text;

namespace GameLib
{
    public class Game
    {
        private int turn;
        private Die playerDice;
        private Die computerDice;
        private int playerScore;
        private int computerScore;
        private int maxScore;
        public Game()
        {
            this.maxScore = 50;            
            this.playerDice = new Die("Player:0");
            this.computerDice = new Die("Comp:0");
            this.playerScore = 0;
            this.computerScore = 0;
            this.turn = 1;
        }
        public void Run()
        {
            while (true)
            {
                if (this.turn == 1)
                {

                    this.NextPlayerTurn();
                    this.turn = 0;
                    
                }
                else
                {
                    this.NextComputerTurn();
                    if (this.computerScore >= this.maxScore && this.playerScore < this.maxScore)
                    {
                        Console.Clear();
                        Console.WriteLine("You lose!!!");
                        return;
                    }
                    if (this.computerScore >= this.maxScore && this.playerScore >= this.maxScore)
                    {
                        Console.Clear();
                        Console.WriteLine("Drawn Game");
                        return;
                    }
                    if (this.playerScore >= this.maxScore)
                    {
                        Console.Clear();
                        Console.WriteLine("You win!!!");
                        return;
                    }
                    this.turn = 1;
                }
                
               
            }
        }
        public void Reset()
        {
            this.playerScore = 0;
            this.computerScore = 0;
            this.turn = 1;
            this.playerDice.SetCaption("Player:0");
            this.computerDice.SetCaption("Comp:0");
            Console.Clear();
            
        }
        public int GetComputerScore()
        {
            return this.computerScore;
        }
        public int GetPlayerScore()
        {
            return this.playerScore;
        }
        private void NextPlayerTurn()
        {
            int points = 0;
            int n;
            char key;
            Console.Clear();
            Console.WriteLine("Points in this turn: " + points);
            Console.WriteLine("Do you want to continue rollig die?? Y/N");
            key = Console.ReadKey(true).KeyChar;
            while ((key == 'y' || key == 'Y'))
            {
                this.playerDice.Roll();
                n = this.playerDice.GetNum();
                while (Console.KeyAvailable)
                    Console.ReadKey(false);
                if (n == 1)
                {
                    Console.Clear();
                    Console.WriteLine("Points in this turn: 0");
                    return;
                }
                else
                    points += n;
                Console.Clear();
                Console.WriteLine("Points in this turn: " + points);
                Console.WriteLine("Do you want to continue rollig die?? Y/N");
                key = Console.ReadKey(true).KeyChar;
           }
           this.playerScore += points;
           this.playerDice.SetCaption("Player:" + this.playerScore);

        }
        private void NextComputerTurn()
        {
            int points = 0;
            int n;
            while ((points <= 20 && (computerScore + points) <= maxScore) || (this.playerScore >= maxScore && (computerScore + points) <= maxScore))
            {
                this.computerDice.Roll();
                n = this.computerDice.GetNum();
                while (Console.KeyAvailable)
                    Console.ReadKey(false);
                if (n == 1)
                {
                    return;
                }
                points += n;    
            }
            this.computerScore += points;
            this.computerDice.SetCaption("Comp:" + this.computerScore);
        }
       
    }
}
